$LARGE
C Screen2.for
*********************************************************************

	INTEGER*4 FUNCTION Fld Index (Name)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name

	DO 10 i = 1, End Screen (Total Number of Screens)
	  IF (Name .EQ. SC Field Name (i)) THEN
	    Fld Index = i
	    RETURN
	  ENDIF
  10	CONTINUE

	Fld Index = 0

	RETURN
	END

*********************************************************************

	SUBROUTINE Set Character Value (Name, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name, Value

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length  (Field)
	Record (Pointer : Pointer + Length - 1) = ' '
	L = LEN (Value)
	IF (L .LT. Length) Length = L
	Record (Pointer : Pointer + Length - 1) = Value (1:Length)

	RETURN
	END

*********************************************************************

	SUBROUTINE Get Character Value (Name, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name, Value

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length  (Field)
	Value = Record (Pointer : Pointer + Length - 1)

	RETURN
	END

*********************************************************************

	SUBROUTINE Set Integer Value (Name, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	INTEGER*4 Value
	CHARACTER*10 Format

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length (Field)

	WRITE (Format, 100) Length
 100	FORMAT ('(I', I2, ')')

	WRITE (Record (Pointer : Pointer + Length - 1), Format) Value

	RETURN
	END

*********************************************************************

	SUBROUTINE Get Integer Value (Name, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	INTEGER*4 Value
	CHARACTER*10 Format

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length (Field)

	WRITE (Format, 100) Length
 100	FORMAT ('(I', I2, ')')

	READ (Record (Pointer : Pointer + Length - 1), Format) Value

	RETURN
	END

*********************************************************************

	SUBROUTINE Set Floating Point Value (Name, Value 8, Decimals)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name, Scratch*20
	REAL*8 Value 8
	REAL*4 Value 4
	CHARACTER*10 Format
	INTEGER*4 Decimals

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length (Field)

	WRITE (Format, 110, ERR = 888) Length, Decimals
	WRITE (Scratch (1:Length), Format, ERR = 888) Value8
	IF (Scratch (1:1) .EQ. '*') THEN
 888	  WRITE (Format, 120) Length, Length-5
	ENDIF
	WRITE (Record (Pointer : Pointer + Length - 1), Format) Value 8
	RETURN

C-----------------------------------------------------------------------

	ENTRY Set 4 Floating Point Value (Name, Value 4, Decimals)

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length (Field)

	WRITE (Format, 110, ERR = 999) Length, Decimals
 110	FORMAT ('(F', I2, '.', I2, ')')
	WRITE (Scratch (1:Length), Format, ERR = 999) Value4
	IF (Scratch (1:1) .EQ. '*') THEN
 999	  WRITE (Format, 120) Length, Length-5
	ENDIF
	WRITE (Record (Pointer : Pointer + Length - 1), Format) Value 4

 120	FORMAT ('(G', I2, '.', I2, ')')
	RETURN
	END

*********************************************************************

	SUBROUTINE Get Floating Point Value (Name, Value 8)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	REAL*8 Value 8
	REAL*4 Value 4
	CHARACTER*10 Format

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length (Field)

	WRITE (Format, 110) Length
	READ (Record (Pointer : Pointer + Length - 1), Format) Value 8

	RETURN

C-----------------------------------------------------------------------

	ENTRY Get 4 Floating Point Value (Name, Value 4)

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Pointer = SC Pointer (Field)
	Length  = SC Length  (Field)

	WRITE (Format, 110) Length
 110	FORMAT ('(G', I2, '.0)')

	READ (Record (Pointer : Pointer + Length - 1), Format) Value 4

	RETURN
	END

*********************************************************************

	SUBROUTINE Set Toggle Value (Name, Position, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	CHARACTER*(*) Value
	INTEGER*4 Position

	Field    = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Length   = SC Length  (Field)
	Pointer  = SC Pointer (Field) + Length * Position
	Record (Pointer : Pointer + Length - 1) = ' '
	L = LEN (Value)
	IF (L .LT. Length) Length = L
	Record (Pointer : Pointer + Length - 1) = Value (1:Length)

	RETURN
	END

*********************************************************************

	SUBROUTINE Get Toggle Value (Name, Position, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	CHARACTER*(*) Value
	INTEGER*4 Position

	Field    = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Length   = SC Length   (Field)
	Position = SC Position (Field)
	Pointer  = SC Pointer  (Field) + Length * Position
	Value = Record (Pointer : Pointer + Length - 1)

	RETURN
	END

*********************************************************************

	SUBROUTINE Set Menu Value (Name, Position, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	INTEGER*4 Position
	CHARACTER*(*) Value
	CHARACTER*10 Format

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Length  = SC Length  (Field+Position)
	Pointer = SC Pointer (Field+Position)
	Record (Pointer : Pointer + Length - 1) = ' '
	L = LEN (Value)
	IF (L .LT. Length) Length = L
	Record (Pointer : Pointer + Length - 1) = Value (1:Length)

	RETURN
	END

*********************************************************************

	SUBROUTINE Get Menu Value (Name, Position, Value)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name
	INTEGER*4 Position
	CHARACTER*(*) Value
	CHARACTER*10 Format

	Field = Fld Index (Name)
	IF (Field .EQ. 0) RETURN
	Position = SC Position (Field)
	Length   = SC Length   (Field+Position)
	Pointer  = SC Pointer  (Field+Position)
	Value = Record (Pointer : Pointer + Length - 1)

	RETURN
	END

*********************************************************************

	SUBROUTINE Write Field (Field, Attribute)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	Att = Attribute

	IF (SC Field Type (Field) .EQ. 4) THEN
	  Main = Field + SC Members (Field)
	  IF (Field .EQ. (Main + SC Position (Main)))
     +	      Att = SC Chosen Attribute (Field)
	ENDIF

	CALL Locate Cursor (SC Row (Field), SC Column (Field))
	Pointer = SC Pointer (Field) +
     +	          SC Length (Field) * SC Position (Field)

	CALL PutStr (
     +	          Record (Pointer :
     +	                  Pointer + SC Length (Field) - 1),
     +                    SC Length (Field),
     +		  SC Row (Field), SC Column (Field),   
     +	          Att)

C	CALL Put Characters (
C     +	          Record (Pointer :
C     +	                  Pointer + SC Length (Field) - 1),
C     +                    SC Length (Field),   
C     +	          Att)
C
	CALL Locate Cursor (SC Row (Field), SC Column (Field))

	RETURN
	END

*********************************************************************

	SUBROUTINE Write Messages (Field)

	IMPLICIT INTEGER*4 (A-Z)
	CHARACTER*80 Out

$INCLUDE: 'SCREEN.STR'

	Pointer = SC M Pointer (Field)
	Length  = SC M Length  (Field)

	DO 10 i = 1, SC Message (Field)

	  READ (Record (Pointer : Pointer + 6), '(2(I2,1X),I1)')
     +	       Row, Column, Attribute


	  CALL PutStr (Record (Pointer+8 : Pointer+Length-1),
     +                 Length-8, 
     +		       Row, Column, Attribute)

C	  CALL Locate Cursor (Row, Column)
C	  CALL Put Characters (Record (Pointer+8 : Pointer+Length-1),
C     +                                  Length-8, Attribute)

	  Pointer = Pointer + Length

  10	CONTINUE

	RETURN
	END

*********************************************************************

	SUBROUTINE Erase Messages (Field)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*80 Spaces

	Spaces = ' '
	Pointer = SC M Pointer (Field)
	Length  = SC M Length  (Field)

	DO 10 i = 1, SC Message (Field)

	  READ (Record (Pointer : Pointer + 6), '(2(I2,1X),I1)')
     +	       Row, Column, Attribute

	  CALL Erase (Row, Column, Length - 8)
	  Pointer = Pointer + Length
  10	CONTINUE

	RETURN
	END

