#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <X11/cursorfont.h>

errorHandler( theDisplay, theErrorEvent )
     Display *theDisplay;
     XErrorEvent  *theErrorEvent;
{
  int bufferLength = 120;
  char theBuffer[ 130 ];
  
  XGetErrorText( theDisplay, theErrorEvent->error_code, theBuffer, bufferLength );

  fprintf( stderr, "X Error: %s\n", theBuffer);
  
  fprintf( stderr, "Serial number of request: %ld Op Code: %d.$d Error Code: %d\n", theErrorEvent->serial,theErrorEvent->request_code,theErrorEvent->minor_code,theErrorEvent->error_code);
  
  fprintf( stderr, "Resource ED of failed request: %ld on display %s.\n",theErrorEvent->resourceid, DisplayString( theDisplay) );
  
}

