C*********************************************************************
C SUBROUTINE Main Menu
C
C Local Variables:
C  Mainermenu    - Name of the main menu in the screen definition file.
C  MainScreen  - Number of the main screen in the screen definition
C                file.
C  Exit        - Logical variable set to .TRUE. when the user wants
C                to exit the program.
C
C This routine displays the main screen and menu, then processes
C the menu option selected by the user.
C
C*********************************************************************
	SUBROUTINE Main Menu

        IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'generic.inc'
        
        CHARACTER*10  Mainermenu
        INTEGER*4     MainScreen
        LOGICAL     Get Yes No, Exit

        DATA Mainermenu    /'MAINMENU  '/
        DATA MainScreen  /2/

C *** Set up the screen
 5      CALL Get New Screen (MainScreen)

 10     CALL Put Menu (Mainermenu)
   
        CALL Display One Field ('PREFIX    ')

        CALL Get Menu Choice (Mainermenu,MenuChoice)

C *** QUIT
        IF (MenuChoice .EQ. 'Quit        ') THEN
	   Exit = Get Yes No (20, 2, 
     +                'Do you really want to QUIT? <Y/N>')
	   IF (Exit) THEN
              CALL Clear Screen
              CALL Reset Screen
              RETURN
           ELSE 
              GOTO 10
           ENDIF

C *** PREFIX
        ELSEIF (MenuChoice .EQ. 'Prefix      ') THEN
           CALL Get Field
           CALL Get Character Value ('PREFIX    ', FilePrefix)
           GOTO 10

C *** DATA
        ELSEIF (MenuChoice .EQ. 'Data        ') THEN
           CALL Data Menu
           GOTO 5
        ENDIF
        END     
