C*********************************************************************
      SUBROUTINE Execute Menu
      
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE '../generic/generic.inc'
      character*30 fmt
      real*8 missing
      real  glyph_max, glyph_min, col_max, col_min
      character*15 brushcolor(0:9)*15
      integer glyph(0:12)
      logical colors, glyphs, rows, okay(maxsamples)

      data missing /1e31/
      data brushcolor /'Peru','Orchid','SlateBlue','SkyBlue','Green'
     &     ,'Yellow','Orange','Red','HotPink','Default'/
      data glyph / 0, 1, 4, 7, 10, 2, 5, 8, 11, 3, 6, 9, 12 /
      
      glyphs = .false.
      rows = .false.
      colors = .false.
      OPEN (UNIT=13, FILE=fileprefix(1:lenstr(fileprefix))
     &     //datafile(1:lenstr(datafile))//'.xgobi'
     &     , status='unknown',err=667)
      OPEN (UNIT=14, FILE=fileprefix(1:lenstr(fileprefix))
     &     //datafile(1:lenstr(datafile))//'.xgobi.col'
     &     , status='unknown',err=667)
      if (nsuppvar .gt. 0) then
         glyphs = .true.
         OPEN (UNIT=15, FILE=fileprefix(1:lenstr(fileprefix))
     &        //datafile(1:lenstr(datafile))//'.xgobi.glyphs'
     &        , status='unknown',err=667)
      end if
      if (nsuppvar .gt. 1) then
         colors = .true.
         OPEN (UNIT=16, FILE=fileprefix(1:lenstr(fileprefix))
     &        //datafile(1:lenstr(datafile))//'.xgobi.colors'
     &        , status='unknown',err=667)
      end if
      if (nsuppvar .gt. 2) then
         rows = .true.
         OPEN (UNIT=17, FILE=fileprefix(1:lenstr(fileprefix))
     &        //datafile(1:lenstr(datafile))//'.xgobi.row'
     &        , status='unknown',err=667)
      end if         

      do i = 1, nvar
         write(14,'(a)') varnam(i)
      enddo
      do i = 1, nsuppvar
         write(14,'(a)') svarnam(i)
      enddo
      fmt = '(  (e12.5,x))'
      write(fmt(2:3),'(i2)') nvar+nsuppvar
      col_max = -1e31
      glyph_max = -1e31
      col_min = 1e31
      glyph_min = 1e31
      k = 0
      do i = 1, nsamples
         okay(i) = .false.
         do j = 1, nvar
            if (pij(i,j) .eq. missing) goto 20
         enddo
         if (glyphs) then
            if (psij(i,1) .eq. missing) goto 20
            if (psij(i,1) .gt. glyph_max) glyph_max = psij(i,1)
            if (psij(i,1) .lt. glyph_min) glyph_min = psij(i,1)
         end if
         if (colors) then
            if (psij(i,2) .eq. missing) goto 20
            if (psij(i,2) .gt. col_max) col_max = psij(i,2)
            if (psij(i,2) .lt. col_min) col_min = psij(i,2)
         end if
         if (rows) then
            if (psij(i,3) .eq. missing) goto 20
            write(17,*) psij(i,3)
         end if
         write(13,fmt,err=666) (pij(i,j),j=1,nvar)
     &        ,(psij(i,j),j=1,nsuppvar)
         okay(i) = .true.
 20   enddo
 666  glyph_max = glyph_max - glyph_min
      if (glyph_max .eq. 0)  glyph_max = 1
      col_max = col_max - col_min
      if (col_max .eq. 0)  col_max = 1
      do i = 1, nsamples
         if (.not. okay(i)) goto 30
         j = int(13*(psij(i,1)-glyph_min)/glyph_max)
         if (j .eq. 13) j = 12
         if (glyphs) write(15,*) glyph(j)
         j = int(10*(psij(i,2)-col_min)/col_max)
         if (j .eq. 10) j = 9
         if (colors) write(16,'(a)') brushcolor(j)
 30   enddo
         
      CLOSE (13)
      CLOSE (14)
      CLOSE (15)
      CLOSE (16)
      CLOSE (17)

      open(14,file=fileprefix(1:lenstr(fileprefix))//'.xgobi.bat'
     &     , status='unknown',err=667)

      write(14,'(a)',err=667) '#!/bin/sh'
      write(14,'(a)',err=667) 'xgobi '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi.col'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi.glyphs'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi.colors'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//
     &     datafile(1:lenstr(datafile))//'.xgobi.row'
      write(14,'(a)',err=667) 'rm -f '
     &     //fileprefix(1:lenstr(fileprefix))//'.xgobi.bat'

      CLOSE (14)
      
      call  system ('chmod +x '//fileprefix(1:lenstr(fileprefix))//
     &     '.xgobi.bat')
      call  system (fileprefix(1:lenstr(fileprefix))//'.xgobi.bat &')
      
 667  return
      END     


