C
C Test.for
C
C example of calling the C system function from Microsoft FORTRAN
C
C FL /c /Od /4Ns /4Nt TEST.FOR
C LINK TEST, TEST, NUL, Clibfor7+Llibc;
C
C----------------------------------------------------------------------
C interface for System call
C
      	INTERFACE TO INTEGER*2 FUNCTION SYSTEM [C,ALIAS:'_system']
     1 		(COMMAND)
      	INTEGER*4 COMMAND
      	END
C----------------------------------------------------------------------
C interface for GetCWD - get current working directory
C
      	INTERFACE TO INTEGER*4 FUNCTION GETCWD [C,ALIAS:'_getcwd']
     1 		(DIRECTORY, N)
      	INTEGER*4 DIRECTORY
	INTEGER*2 N
      	END
C----------------------------------------------------------------------
C interface for CHDIR - change working directory
C
      	INTERFACE TO INTEGER*2 FUNCTION CHDIR [C,ALIAS:'_chdir']
     1 		(DIRECTORY)
      	INTEGER*4 DIRECTORY
      	END
C----------------------------------------------------------------------
C interface for Rename - rename file
C
      	INTERFACE TO INTEGER*2 FUNCTION RENAME [C,ALIAS:'_rename']
     1 		(OLDNAME, NEWNAME)
      	INTEGER*4 OLDNAME, NEWNAME
      	END
C----------------------------------------------------------------------
C interface for Remove - delete file
C
      	INTERFACE TO INTEGER*2 FUNCTION DELETE [C,ALIAS:'_remove']
     1 		(NAME)
      	INTEGER*4 NAME
      	END
C----------------------------------------------------------------------
      	PROGRAM TEST

      	INTEGER*2 	SYSTEM, CHDIR, RENAME, DELETE
	INTEGER*2	RETURNCODE
	INTEGER*4 	GETCWD, CWDCODE

      	CHARACTER*80 	PROGRM
	CHARACTER*51 	DIRECTORY, OLDDIR
	CHARACTER*20 	OLDNAME, NEWNAME
	CHARACTER*1	CH

	DATA OLDNAME /'test.for'C/
	DATA NEWNAME /'test.sav'C/

C----------------------------------------------------------------------
C test for GETCWD
C
	WRITE (*, *) 'GETCWD TEST '
	CWDCODE = GETCWD (LOC (DIRECTORY), INT2 (50))
	IF (CWDCODE .EQ. 0) WRITE (*,*) 'error getting CWD'
	OLDDIR = DIRECTORY
	WRITE (*,*)  'DIRECTORY = ', DIRECTORY
 	WRITE (*, *) 'RETURN CODE = ', CWDCODE
	WRITE (*, *) 'Press enter '
	READ (*, '(A)') CH

C----------------------------------------------------------------------
C test for CHDIR
C
	WRITE (*, *) 'CHDIR TEST '
	WRITE (*, *) 'CHANGING DIRECTORY to .., calling getcwd '
	DIRECTORY  = '..'C
	RETURNCODE = CHDIR (LOC (DIRECTORY))
 	WRITE (*, *) 'RETURN CODE = ', RETURNCODE

	CWDCODE = GETCWD (LOC (DIRECTORY), INT2 (50))
	WRITE (*,*)  'NEW DIRECTORY = ', DIRECTORY

	RETURNCODE = CHDIR (LOC (OLDDIR))

	WRITE (*, *) 'Press enter '
	READ (*, '(A)') CH

C----------------------------------------------------------------------
C test for RENAME
C
	WRITE (*, *) 'RENAME TEST'
	WRITE (*, *) 'RENAMING test.for to test.sav'
	PROGRM = 'DIR TEST.*'C
	RETURNCODE = SYSTEM (LOC (PROGRM))

	RETURNCODE = RENAME (LOC (OLDNAME), LOC (NEWNAME))
 	WRITE (*, *) 'RETURN CODE = ', RETURNCODE

	PROGRM = 'DIR TEST.*'C
	RETURNCODE = SYSTEM (LOC (PROGRM))

	RETURNCODE = RENAME (LOC (NEWNAME), LOC (OLDNAME))

	WRITE (*, *) 'Press enter '
	READ (*, '(A)') CH
	
C----------------------------------------------------------------------
C test for DELETE
C
	WRITE (*, *) 'DELETE TEST'
	WRITE (*, *) 'DELETING TEST.OBJ '

	PROGRM = 'DIR TEST.*'C
	RETURNCODE = SYSTEM (LOC (PROGRM))

	OLDNAME = 'TEST.OBJ'C
	RETURNCODE = DELETE (LOC (OLDNAME))
 	WRITE (*, *) 'RETURN CODE = ', RETURN

	RETURNCODE = SYSTEM (LOC (PROGRM))
	WRITE (*, *) 'Press enter '
	READ (*, '(A)') CH

C----------------------------------------------------------------------
C test for SYSTEM
C
	WRITE (*, *) 'SYSTEM TEST '
 10	WRITE (*,*) 'ENTER COMMAND , or cntrl-break to quit'
	READ  (*, '(a)') PROGRM

C Strings in C end with a NULL
	PROGRM (80:80) = CHAR (0)

	RETURNCODE = SYSTEM (LOC (PROGRM))

 	WRITE (*, *) 'RETURN CODE = ', RETURNCODE
	GOTO 10
      	END

