
C Examine.for - subroutine to display scrolling results list for XVALID
C
C---------------------------------------------------------------------
	SUBROUTINE Examine

	IMPLICIT INTEGER*4 (A-Z)

cc	PARAMETER (KEYUP   = 72, KEYDWN   = 80)
cc	PARAMETER (KEYPGUP = 73, KEYPGDWN = 81)
cc	PARAMETER (KEYEND  = 79, KEYHOME  = 71)
cc	PARAMETER (KEYQUIT = 16, KEYESC   =  1)

		include  'xvalid.dec'

	CHARACTER	Message*72, Scratch*16, Ch*1
cclong
	character	massage*72
	integer*4	key
cc
	INTEGER*4	Scan, Ascii
	INTEGER*4	TopRec, BottomRec, Row1, Row2
	INTEGER*4	FirstRec, LastRec, NumPressed

	DATA    Row1 /3/,    Row2 /18/
	DATA Column1 /1/, Column2 /78/

C Initialize
	massage = '    Use <q>uit, <f>orward, <r>everse,'
     +       //' <n>ext screen, <p>revious screen,'
	message = 
     &   '<t>op, <b>ottom, or <1> to <9> to move by tenths of pairs.'

	IF (Ndata .LT. 16) THEN
	  TopRec 	= 1
	  BottomRec	= Ndata
	  CALL Put Escreen (TopRec, BottomRec)
	  CALL Flash (20, 2, 'Press any key to exit ')
	  RETURN
	ENDIF

	TopRec 		= 1
	BottomRec	= TopRec + 15
	CALL Put Escreen (TopRec, BottomRec)

 	CALL PutStr (Massage, 72, 20, 2, 2)
 	CALL PutStr (Message, 72, 22, 2, 2)
20	call getthekey (key)
	Ch = CHAR (key)
	IF (ch .EQ. 'q' .OR. ch .EQ. 'Q') RETURN

	IF     (ch .EQ. 'f') THEN
	   IF (BottomRec .LT. Ndata) THEN
              BottomRec = BottomRec + 1
ccc	      TopRec	= TopRec + 1 
ccc
              TopRec    = BottomRec - 15
              CALL Put Escreen (TopRec, BottomRec)
ccc
cclong Note the +1 and +2 which were serendipitously added...
cc	      CALL Scroll Window (-1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (-1, Row1+1, Column1, Row2+2, Column2)
ccc	      CALL Put ERecord (BottomRec, Row2)
	   ENDIF	   

	ELSEIF (ch .EQ. 'r') THEN
	   IF (TopRec .GT. 1) THEN
	      TopRec	= TopRec -1 
ccc	      BottomRec = BottomRec -1
ccc
              BottomRec = TopRec + 15
              CALL Put Escreen (TopRec, BottomRec)
ccc
ccibid	      CALL Scroll Window (1, Row1, Column1, Row2, Column2)
ccc	      CALL Scroll Window (1, Row1+1, Column1, Row2+2, Column2)
ccc	      CALL Put ERecord (TopRec, Row1)
	   ENDIF	   

	ELSE IF (ch .EQ. 't') THEN
	   IF (TopRec .NE. 1) THEN
	      TopRec 	= 1
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF	

	ELSEIF (ch .EQ. 'b') THEN
	   IF (BottomRec .LT. Ndata) THEN
	      TopRec 	= Ndata - 15
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF

	ELSEIF (ch .EQ. 'n') THEN
	   IF (BottomRec + 16 .LT. Ndata) THEN
	      TopRec 	= TopRec + 16
	      BottomRec = TopRec + 15
	   ELSE
	      TopRec 	= Ndata - 15
	      BottomRec = TopRec + 15
	   ENDIF
	   CALL Put Escreen (TopRec, BottomRec)

	ELSEIF (ch .EQ. 'p') THEN
	   IF (TopRec - 16 .GE. 1) THEN
	      TopRec 	= TopRec - 16
	      BottomRec = TopRec + 15
	   ELSE
	      TopRec 	= 1
	      BottomRec = TopRec + 15
	   ENDIF
	   CALL Put Escreen (TopRec, BottomRec)

	ELSEIF (Ch .GE. '1' .AND. Ch .LE. '9') THEN
	   NumPressed = ICHAR (Ch) - ICHAR ('0')
	   Krec = (Ndata) * NumPressed/10
	   IF (Krec + 16 .LT. Ndata) THEN
	      TopRec = Krec
	      BottomRec = TopRec + 15
	      CALL Put Escreen (TopRec, BottomRec)
	   ENDIF	        	   
	ENDIF
	GOTO 20
	END

C----------------------------------------------------------------------
C Put PScreen - Put out examine  screen

	SUBROUTINE Put ESCreen (TopRec, BottomRec) 
	IMPLICIT INTEGER*4 (A-Z)

	DO 10 I = TopRec, BottomRec
	   CALL Put ERecord (I, I - TopRec + 3)
 10	CONTINUE	
	RETURN
 	END	 

C----------------------------------------------------------------------
C Put PRecord - Put out examine line
				
	SUBROUTINE Put ERecord (Rec, Row) 

	IMPLICIT INTEGER*4 (A-Z)

		include  'xvalid.dec'

	CHARACTER	Scratch*14, Miss*14
	CHARACTER	Ifmt*4, Rfmt*7
	INTEGER*4	Rec, Row, Tptr

	DATA IFmt /'(I5)'/, Rfmt /'(F14.3)'/
	DATA Miss /'          .   '/

C Get pointer to array values, based upon sorted zscores
	Tptr = Zptr (Rec)
	WRITE (Scratch (1:5), Ifmt) Tptr
	CALL PutStr (Scratch,  5, Row,  3, 0)

	IF (Data (Tptr) .LT. Missing) THEN
	  WRITE (Scratch, Rfmt) Data (Tptr)
	  CALL PutStr (Scratch, 14, Row,  8, 0)
	ELSE
	  CALL PutStr (Miss, 14, Row,  8, 0)
	ENDIF

	IF (Estimate (Tptr) .LT. Missing) THEN
	  WRITE (Scratch, Rfmt) Estimate (Tptr)
	  CALL PutStr (Scratch, 14, Row, 22, 0)
	  WRITE (Scratch, Rfmt) Difference (Rec)
	  CALL PutStr (Scratch, 14, Row, 36, 0)
	ELSE
	  CALL PutStr (Miss, 14, Row, 22, 0)
	  CALL PutStr (Miss, 14, Row, 36, 0)
	ENDIF

	IF (StdDev (Tptr) .LT. Missing) THEN
	  WRITE (Scratch, Rfmt) StdDev (Tptr)
	  CALL PutStr (Scratch, 14, Row, 50, 0)
	  WRITE (Scratch, Rfmt) Zscore (Tptr)
	  CALL PutStr (Scratch, 14, Row, 64, 0)
	ELSE
	  CALL PutStr (Miss, 14, Row, 50, 0)
	  CALL PutStr (Miss, 14, Row, 64, 0)
	ENDIF
	RETURN
	END


