
C Write.for
C----------------------------------------------------------------------
C Write Estimates - subroutine to write XVALID estimates to output file
C
	SUBROUTINE Write Estimates (File, Error) 

		include 'xvalid.dec'

	LOGICAL	Exist, Answer, GetYesNo
	CHARACTER*65	File, TTitle*80
	LOGICAL		Error

	Error = .FALSE.
	OPEN (UNIT = 10, FILE = File, status='unknown', ERR = 999)
	CALL Erase (20, 2, 76)

C Write header stuff
	Ttitle = 'XVALID results from kriging '//VarNam (Var)//
     +		  ' from file '//Data File
	WRITE (10, '(A70)' , ERR = 999)  TTitle
	WRITE (10, '(I2)'  , ERR = 999)   7
	WRITE (10, '(2A10)', ERR = 999) VarNam (Xvar), Units (Xvar)
	WRITE (10, '(2A10)', ERR = 999) VarNam (Yvar), Units (Yvar)
	WRITE (10, '(2A10)', ERR = 999) VarNam (Var),  Units (Var)
	WRITE (10, '(2A10)', ERR = 999) 'Zstar     ',  Units (Var)
	WRITE (10, '(2A10)', ERR = 999) 'Zsdev     ',  'No Units  '
	WRITE (10, '(2A10)', ERR = 999) 'Zstar - Z ',  Units (Var)
	WRITE (10, '(2A10)', ERR = 999) 'Zscore    ',  'No Units  '

C Write data
	DO 10 I = 1, Ndata
	    WRITE (10, 100, ERR = 999) 	XData      (I),
     +                      		YData      (I), 
     +                      		Data       (I), 
     +                      		Estimate   (I),
     +                      		StdDev     (I),
     +                      		Difference (I),
     +			    		Zscore     (I)	
 10	CONTINUE
	CLOSE (10)
 100	FORMAT (7G15.5)
	RETURN

 999	CLOSE (10)
	Error = .TRUE.
 	RETURN
	END
             		

	


